﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
#Region Copyright
'  Project: atHome - Tool Domoticz Scripts Viewer
'  Copyright (C) 2018 Robert W.B. Linn, Pinneberg, Germany.
'
'  InputDialog: Class module text input dialog
'
'  Version: 20181007
'
'  This project is free software; you can redistribute it And/Or
'  modify it under the terms of the GNU Lesser General Public
'  License As published by the Free Software Foundation; either
'  version 2 of the License, Or (at your option) any later version.
'
'  This project Is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE. See the GNU
'  Lesser General Public License For more details.
'
'  You should have received a copy of the GNU Lesser General Public
'  License along with this project; If Not, write To the
'  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
'  Boston, MA 02111-1307, USA.
#End Region

#Region Notes

#End Region

Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private TITLE As String = "Settings"
	Private HINT As String = $"Domoticz Server Connection parameter: IP address, port (default 22), username & password.${CRLF}${CRLF}"$ & _
							 $"Remote path to the Domoticz database (domoticz.db), local folder (can be left blank) and databse filename (domoticz.db).${CRLF}${CRLF}"$ & _ 
							 $"Viewer font size."$
	Private ListViewSettings As ListView
	Private ButtonHint As Button
	Private ButtonCancel As Button
	Private ButtonOK As Button

	Public	POSITIVE As Int = 1				'Dialog result indicator for button OK
	Public	NEGATIVE As Int = 0				'Dialog result indicator for button CANCEL
	Private	mResult As Int = NEGATIVE		'Handle the dialog result being returned
	Public	Settings As Map
	
	Private mSettings As Map
	Private mSettingsOrder As String
End Sub

'Initializes the object. 
Public Sub Initialize(Parent As Form, SettingsMap As Map, SettingsOrder As String)
	frm.Initialize("frm", 400dip, 400dip)
	frm.Title = TITLE
	frm.SetFormStyle("UNDECORATED")
	frm.RootPane.LoadLayout("settingsdialog")
	
	mSettings = SettingsMap
	mSettingsOrder = SettingsOrder
	frm.Stylesheets.Add(File.GetUri(File.DirAssets, "main.css"))
	CSSUtils.SetBackgroundColor(ButtonHint, fx.Colors.Transparent)
	ListView_Create
End Sub

Public Sub Show As Int
	frm.ShowAndWait
	Return mResult
End Sub

Private Sub ButtonHint_Click
	fx.Msgbox2(frm, HINT, "Settings", "OK", "", "", fx.MSGBOX_INFORMATION)
End Sub

Private Sub ButtonOK_Click
	' Update the settings
	SettingsUpdate
	' Assign the settings to the dialog result
	Settings = mSettings
	mResult = POSITIVE
	frm.close
End Sub

Private Sub ButtonCancel_Click
	mResult = NEGATIVE
	frm.close
End Sub

#Region ListView
Private Sub ListView_Create
	' Get the settings order
	Dim Items() As String = Regex.Split(";", mSettingsOrder)
	' Iterate over keys and values
	For Each Key As String In Items
		Dim Value As String = mSettings.Get(Key)
		Dim editfield As TextField
		editfield.Initialize("ListviewEditField")
		editfield.Tag = Key
		editfield.Text = Value
		editfield.TooltipText = $"Settings key: ${Key}"$
		ListViewSettings.Items.Add(editfield)
	Next
End Sub

Private Sub ListViewSettings_SelectedIndexChanged(Index As Int)
	Dim editfield As TextField = ListViewSettings.Items.Get(Index)
	Log($"Setting ${editfield.Tag}: ${editfield.Text}"$)
End Sub

Private Sub SettingsUpdate
	For i = 0 To ListViewSettings.Items.Size - 1
		Dim editfield As TextField = ListViewSettings.Items.Get(i)
		mSettings.Put(editfield.Tag, editfield.Text)
	Next
End Sub
#End Region
